---
title: MediaStream.onaddtrack
slug: Web/API/MediaStream/onaddtrack
tags:
  - API
  - Event Handler
  - Media Streams API
  - MediaStream
  - Property
  - Reference
---
<p>{{APIRef("Media Streams API")}}</p>

<p><span class="seoSummary">The <strong><code>MediaStream.onaddtrack</code></strong> property is an {{domxref("EventHandler")}} which specifies a function to be called when the {{event("addtrack")}} event occurs on a {{domxref("MediaStream")}} instance. This happens when a new track of any kind is added to the media stream.</span> This event is fired when the browser adds a track to the stream (such as when a {{domxref("RTCPeerConnection")}} is renegotiated or a stream being captured using {{domxref("HTMLMediaElement.captureStream()")}} gets a new set of tracks because the media element being captured loaded a new source.</p>

<p>The <code>addtrack</code> event does <em>not</em> get fired when JavaScript code explicitly adds tracks to the stream (by calling {{domxref("MediaStream.addTrack", "addTrack()")}}).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>MediaStream</em>.onaddtrack = <em>eventHandler</em>;
</pre>

<h3 id="Value">Value</h3>

<p>This should be set to a function which you provide that accepts as input a {{domxref("MediaStreamTrackEvent")}} object representing the {{event("addtrack")}} event which has occurred. The {{domxref("MediaStreamTrack")}} representing the track which was added is specified in the event's {{domxref("MediaStreamTrackEvent.track", "track")}} property.</p>

<h2 id="Example">Example</h2>

<p>This example adds a listener which, when a new track is added to the stream, appends a new item to a list of tracks; the new item shows the track's <code>kind</code> (<code>"audio"</code> or <code>"video"</code>) and <code>label</code>.</p>

<pre class="brush: js">stream.onaddtrack = function(event) {
  let trackList = document.getElementById("tracks");
  let label = document.createElement("li");

  label.innerHTML = event.track.kind + ": " + event.track.label;
  trackList.appendChild(label);
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Media Capture', '#event-mediastream-addtrack', 'MediaStream.onaddtrack') }}</td>
   <td>{{ Spec2('Media Capture') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.MediaStream.onaddtrack")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{event("addtrack")}} event and its type, {{domxref("MediaStreamTrackEvent")}}.</li>
</ul>
